#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include "libuvc/libuvc.h"

typedef enum _UVC_PropertyValueType{ Default, Maximum, Minimum, Current }UVC_PropertyValueType;
typedef enum _PowerlineFrequency{ _60Hz, _50Hz }PowerlineFrequency;

typedef struct _Ziggi_HD_Plus
{
	const uvc_format_desc_t* (*getStreamFormat)();
	void(*setStreamFormat)(enum uvc_frame_format format, int width, int height, int fps);

	
	void(*startStreamming)(uvc_frame_callback_t *cb);
	void(*stopStreamming)();
	void(*setStatusCallback)(void *status_cb);

	void(*startFocus)();
	void(*setBrightness)(short value);
	void(*getBrightness)(short *value, UVC_PropertyValueType type);
	void(*setContrast)(short value);
	void(*getContrast)(short *value, UVC_PropertyValueType type);
	void(*setGamma)(short value);
	void(*getGamma)(short *value, UVC_PropertyValueType type);
	void(*setHue)(short value);
	void(*getHue)(short *value, UVC_PropertyValueType type);
	void(*setSaturation)(short value);
	void(*getSaturation)(short *value, UVC_PropertyValueType type);
	void(*setSharpness)(short value);
	void(*getSharpness)(short *value, UVC_PropertyValueType type);
	void(*setWhiteBalance)(short value);
	void(*getWhiteBalance)(short *value, UVC_PropertyValueType type);
	void(*setAutoWhiteBalance)(bool value);
	void(*getAutoWhiteBalance)(bool *value, UVC_PropertyValueType type);
	void(*setFocus)(bool isFocusLock, short focusDistance);
	void(*getFocus)(bool *value, UVC_PropertyValueType type);
	void(*getFocusValue)(short *value, UVC_PropertyValueType type);
	void(*setAutoExposureLock)(bool value);
	void(*getAutoExposureLock)(bool *value);
	void(*setExposure)(short value);
	void(*getExposure)(short *value, UVC_PropertyValueType type);
	void(*setFrequency)(PowerlineFrequency value);
	void(*getFrequency)(PowerlineFrequency *value, UVC_PropertyValueType type);
	void(*getFirmwareVersion)(void* value);
}Ziggi_HD_Plus;

